#include "Arduino101_board.h"
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This generated code may be freely used for both private and commercial use
   provided this copyright is maintained.
*/

// dimensions in 1/10"
// 19 x 24 pin dims, but use 22 height
Arduino101_board::Arduino101_board(pfodDwgs *_dwgsPtr)  : pfodControl(_dwgsPtr)  {
  z_idx = pfodDwgs::reserveIdx(1); // LED indicator
  ledOn = 0;
}

void Arduino101_board::setLed(byte on) {
  ledOn = on;
}

void Arduino101_board::setBase(int c, int r) {
  baseCol = c;
  baseRow = r;
}

int Arduino101_board::getBaseCol() {
  return baseCol;
}

int Arduino101_board::getBaseRow() {
  return baseRow;
}


void Arduino101_board::drawFirst() {
  dwgsPtr->pushZero(baseCol, baseRow);
}

void Arduino101_board::drawLast() {
  update(); // update with current state
  dwgsPtr->popZero(); // undo move
}

void Arduino101_board::drawPins() {

  dwgsPtr->pushZero(0, boardRows);
  int i = 0;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("RX\u2190")).bold().fontSize(-10).offset(boardCols - 0.25 - 2.5,  - (i * 1)).send();
  i = 1;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("TX\u2192")).bold().fontSize(-10).offset(boardCols - 0.25 - 2.5,  - (i * 1)).send();
  dwgsPtr->pushZero(boardCols - 0.25, -8.0);
  for (i = 6; i < 10; i++) {
    dwgsPtr->rectangle().filled().size(0.5, 0.5).offset(0, -0.5 - (i * 1)).send();
  }
  dwgsPtr->pushZero(-1.25, 0);
  i = 6;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("GND")).bold().fontSize(-10).offset(0, -0.5 - (i * 1) + 0.25).send();
  i = 7;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("AREF")).bold().fontSize(-10).offset(0, -0.5 - (i * 1) + 0.25).send();
  i = 8;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("SDA")).bold().fontSize(-10).offset(0, -0.5 - (i * 1) + 0.25).send();
  i = 9;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("SCL")).bold().fontSize(-10).offset(0, -0.5 - (i * 1) + 0.25).send();

  i = 5;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("LED")).bold().fontSize(-10).offset(-2.5, -0.5 - (i * 1) + 0.25).send();
  dwgsPtr->pushZero(-1.25, -0.5 - (i * 1) + 0.25, 0.3);
  dwgsPtr->rectangle().idx(z_idx).filled().color(dwgsPtr->WHITE).centered().send();
  dwgsPtr->popZero(); // undo move

  dwgsPtr->popZero(); // undo move
  dwgsPtr->popZero(); // undo move

  dwgsPtr->pushZero(0, -7);
  dwgsPtr->pushZero(-0.25, 0.0);
  for (i = 0; i < 8; i++) {
    dwgsPtr->rectangle().filled().size(0.5, 0.5).offset(0, -0.25 - (i * 1)).send();
  }
  dwgsPtr->pushZero(0, 7);
  for (i = 0; i < 6; i++) {
    dwgsPtr->rectangle().filled().size(0.5, 0.5).offset(0, -0.25 - (i * 1)).send();
  }
  dwgsPtr->popZero(); // undo move
  dwgsPtr->popZero(); // undo move
  i = 0;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("Vin")).bold().fontSize(-10).offset(1.3 , -0.25 - (i * 1) + 0.25).send();
  i = 1;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("GND")).bold().fontSize(-10).offset(1.5 , -0.25 - (i * 1) + 0.25).send();
  i = 2;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("GND")).bold().fontSize(-10).offset(1.5 , -0.25 - (i * 1) + 0.25).send();
  i = 3;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("5V")).bold().fontSize(-10).offset(1.5 - 0.25 , -0.25 - (i * 1) + 0.25).send();
  i = 4;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("3.3V")).bold().fontSize(-10).offset(1.5 + 0.1 , -0.25 - (i * 1) + 0.25).send();
  i = 5;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("RESET")).bold().fontSize(-10).offset(1.5 + 0.6 , -0.25 - (i * 1) + 0.25).send();
  i = 6;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("IOREF")).bold().fontSize(-10).offset(1.5 + 0.4 , -0.25 - (i * 1) + 0.25).send();
  i = 7;
  dwgsPtr->label().color(dwgsPtr->WHITE).text(F("ATN")).bold().fontSize(-10).offset(1.5 , -0.25 - (i * 1) + 0.25).send();

  dwgsPtr->popZero(); // undo move
  dwgsPtr->popZero(); // undo move
}

void Arduino101_board::drawBasicOutline() {
  dwgsPtr->rectangle().filled().size(boardCols + 2, boardRows + 1.5 + 2).offset(-1, -1.5).color(26).send();
  dwgsPtr->label().bold().color(dwgsPtr->WHITE).text(F("Arduino")).fontSize(-3).offset(9, 5).send();

  dwgsPtr->pushZero(9, 8);
  dwgsPtr->rectangle().filled().color(dwgsPtr->WHITE).size(7, 4).centered().send();
  dwgsPtr->label().bold().color(26).text(F("101")).fontSize(+4).send();
  dwgsPtr->popZero();
}

void Arduino101_board::draw() {
  drawOutline();
}

void Arduino101_board::drawOutline() {
  dwgsPtr->rectangle().filled().size(boardCols + 2, boardRows + 1.5 + 2).offset(-1, -1.5).color(26).send();
  dwgsPtr->rectangle().filled().size(4.7, 6.3).offset(12.5 - 1, -4).color(dwgsPtr->SILVER).send();
  dwgsPtr->rectangle().filled().size(3.5, 5.3).offset(0.5, -1 - 1.5).color(dwgsPtr->BLACK).send();

  dwgsPtr->pushZero(8 - 1 + 1.15, 0 + 1.15);
  dwgsPtr->rectangle().filled().size(2.3, 2.3).centered().color(dwgsPtr->SILVER).send(); //.offset(8 - 1, 0)
  dwgsPtr->circle().filled().radius(0.65).color(dwgsPtr->BLUE).send(); //.offset(8 - 1 + 1.15, 0 + 1.15)
  dwgsPtr->popZero();

  dwgsPtr->pushZero(17.8 - 1 + 1.15,  0 + 1.15);
  dwgsPtr->rectangle().filled().size(2.3, 2.3).centered().color(dwgsPtr->SILVER).send(); //.offset(17.8 - 1, 0)
  dwgsPtr->circle().filled().radius(0.65).color(dwgsPtr->BLUE).send(); //.offset(17.8 - 1 + 1.15, 0 + 1.15)
  dwgsPtr->popZero();

  dwgsPtr->rectangle().filled().size(9, 3).offset(-1, boardRows - 3 + 2).color(215).send();

  dwgsPtr->rectangle().filled().size(3.1, 4.3).offset(8.5, 13).color(dwgsPtr->BLACK).send();

  dwgsPtr->label().bold().color(dwgsPtr->WHITE).text(F("Arduino")).fontSize(-3).offset(9, 5).send();

  dwgsPtr->pushZero(9, 8.0);
  dwgsPtr->rectangle().filled().color(dwgsPtr->WHITE).size(7, 4).centered().send();
  dwgsPtr->label().bold().color(26).text(F("101")).fontSize(+4).send();//.offset(9.5, 7.75).send();
  dwgsPtr->popZero();

}

void Arduino101_board::update() {
  if (ledOn) {
    dwgsPtr->rectangle().idx(z_idx).filled().color(118).centered().send();
  } else {
    dwgsPtr->rectangle().idx(z_idx).filled().color(dwgsPtr->WHITE).centered().send();
  }
}

