#ifndef Arduino101_board_h
#define Arduino101_board_h
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include <pfodControl.h>

class Arduino101_board : public pfodControl {
  public:
    Arduino101_board(pfodDwgs *_dwgsPtr);
    void draw();
    void update();
    void drawFirst();
    void drawLast();
    void setBase(int c, int r);
    void drawOutline();
    void drawPins();
    int getBaseCol();
    int getBaseRow();
    void drawBasicOutline();
    void setLed(byte on);


    static const int boardCols = 19;
    static const int boardRows = 22;

  private:
    int baseCol;
    int baseRow;
    int z_idx;
    byte ledOn;


};
#endif // Arduino101_board_h
