#ifndef HL_Switch_h
#define HL_Switch_h
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include <pfodControl.h>

class HL_Switch : public pfodControl {
  public:
    HL_Switch(char _cmd, pfodDwgs *_dwgsPtr);
    void draw();
    void update();
    void setBase(int c, int r);
    void setBaseScaling(double _scaling);
    char getCmd();
    void setValue(int newValue);
    void forceFullUpdate();

  private:
    char buttonCmd;
    void fullUpdate();
    boolean haveStateChange();
    void saveCurrentState();
    int baseCol;
    int baseRow;
    float baseScaling;
    int z_idx;
    int previousValue; // for update
    boolean forceUpdate;
};
#endif // HL_Switch_h





